<?php

class ControllerPaymentbitpay extends Controller {
	protected function index() {


    	$this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');
		
		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$this->load->library('encryption');
		
		$encryption = new Encryption($this->config->get('config_encryption'));
		
		if($this->currency->getCode()!='RLS') {
		$this->currency->set("RLS");
		echo('<html><head><meta http-equiv="refresh" CONTENT="1; url=index.php?route=checkout/confirm"></head><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1578;&#1606;&#1592;&#1740;&#1605; &#1575;&#1585;&#1586; &#1576;&#1607; &#1585;&#1740;&#1575;&#1604;...<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
		die();
		}
		
		$this->data['Amount'] = @$this->currency->format($order_info['total'], $order_info['currency'], $order_info['value'], FALSE);
		$this->data['PIN']=$this->config->get('bitpay_PIN');
		
		$this->data['return'] = $this->url->https('checkout/success');
		$this->data['cancel_return'] = $this->url->https('checkout/payment');

		$this->data['back'] = $this->url->https('checkout/payment');

		

		$amount = intval($this->data['Amount']);
		$callbackUrl = urlencode($this->url->https('payment/bitpay/callback&order_id='.$encryption->encrypt($this->session->data['order_id'])));
		
		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL,'https://bitpay.ir/payment/gateway-send');
		curl_setopt($ch,CURLOPT_POSTFIELDS,"api={$this->data['PIN']}&amount=$amount&redirect=$callbackUrl");
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$res = curl_exec($ch);
		curl_close($ch);
		
		
		if($res > 0 && is_numeric($res)){

			$this->data['action'] = "https://bitpay.ir/payment/gateway-$res";
		
		} else {
			
			$this->CheckState($res);
			die();
		}

//
		
		$this->id       = 'payment';
		$this->template = $this->config->get('config_template') . 'payment/bitpay.tpl';
		
		$this->render();		
}

	private function CheckState($status) {

	switch($status){
	
		case "-1" :
			echo "طول api ارسالی نامعتبر است";
			break;
		case "-2" :
			echo "مقدار ارسالی از 1000ریال کمتر است";
			break;
		case "-3" :
			echo "مقدار redirect تعیین نشده است";
			break;
		case "-4" :
			echo "تراکنش ناموفق بوده است، لطفاً با مدیریت تماس حاصل فرمایید";
			break;
		case "1":
			echo "پرداخت با موفقیت انجام شد";
			break;
		
		default :
			echo "مشکل در برقراری ارتباط با درگاه!";
			break;
	}	
	
	return true;
}

function verify_payment($authority, $amount){
	
	$trans_id = $_POST['trans_id'];
	$id_get = $_POST['id_get'];
	$this->data['PIN'] = $this->config->get('bitpay_PIN');
	
	if(is_numeric($trans_id) && $trans_id > 0){

		$ch = curl_init();
		curl_setopt($ch,CURLOPT_URL,'https://bitpay.ir/payment/gateway-result-second');
		curl_setopt($ch,CURLOPT_POSTFIELDS,"api={$this->data['PIN']}&id_get=$id_get&trans_id=$trans_id");
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		$res = curl_exec($ch);
		curl_close($ch);

		
		if ($res == '')
			{echo  "Error: can not connect to bitpay.<br>";return false;}
		
		else {
			
			
			
			$this->CheckState($res);
			
			if($res == 1)
				return true;

			else {
				return false;
				echo'ERR'.$res;
			}
		
		}
	} 
	
	else {
		return false;
	}
	
	
	return false;
}

	public function callback() {
		$this->load->library('encryption');

		$encryption = new Encryption($this->config->get('config_encryption'));
		$trans_id = @$_POST['trans_id'];
		$id_get =   @$_POST['id_get'];
		$order_id = $encryption->decrypt(@$this->request->get['order_id']);
		$MerchantID=$this->config->get('bitpay_PIN');
		$debugmod=false;
		
		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($order_id);
		$Amount = @$this->currency->format($order_info['total'], $order_info['currency'], $order_info['value'], FALSE);
		$amount = $Amount/10;
		if ($order_info && $id_get > 0) {
		
		if(($this->verify_payment($trans_id, $amount)) ) {
		
						$this->model_checkout_order->confirm($order_id, $this->config->get('bitpay_order_status_id'),'رسید دیجیتالی bitpay '.$trans_id);
						
						
						
						$this->response->setOutput('<html><head><meta http-equiv="refresh" CONTENT="2; url=index.php?route=checkout/success"></head><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1576;&#1575; &#1578;&#1588;&#1705;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; &#1578;&#1705;&#1605;&#1740;&#1604; &#1588;&#1583;. &#1604;&#1591;&#1601;&#1575; &#1670;&#1606;&#1583; &#1604;&#1581;&#1592;&#1607; &#1589;&#1576;&#1585; &#1705;&#1606;&#1740;&#1583; &#1608; &#1740;&#1575; <a href="index.php?route=checkout/success"><b>&#1575;&#1740;&#1606;&#1580;&#1575; &#1705;&#1604;&#1740;&#1705; &#1606;&#1605;&#1575;&#1740;&#1740;&#1583;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
						
						
					
        			
		
						
					}
		
		} else {
			
						$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">&#1582;&#1591;&#1575; &#1583;&#1585; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578;.<br /><br /><a href="index.php?route=checkout/cart"><b>&#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1576;&#1607; &#1601;&#1585;&#1608;&#1588;&#1711;&#1575;&#1607;</b></a></td><td>&nbsp;</td></tr></table></body></html>');
						
		}
	}
}
?>
